#ifndef MadxViewerPar_h
#define MadxViewerPar_h
/*Piotr Skowronski, CERN*/

#include "TGedFrame.h"
#include "TLegend.h"

class MadxViewer;
class TGTextButton;
class TGCheckButton;
class TString;
class TGNumberEntry;
class TGComboBox;
class TAxis;

class MadxViewerPar : public TObject {

public:
   MadxViewerPar(MadxViewer* master = 0x0);
   virtual ~MadxViewerPar();

   void Create(TGCompositeFrame* hostframe);
   Bool_t Init();
   void ConnectSignals2Slots();

   void DrawParametric();
   void ReDraw();
   void Clear();

   void AddFunction(Int_t n, const char* name);

   void UpdatePlots();
   void SetYRange();
   void SetKnobs();
   
private:
   MadxViewer          *fMaster;


   TGTextButton        *fDrawButton;
   
   TGCheckButton       *fSameButton;
   TGString            *fVarString;

   TGHorizontalFrame   *fVarFrame;
   TGLabel             *fVarLabel;
   TGComboBox          *fVarComboBox;


   TGCompositeFrame    *fHostFrame; //not to be deleted belongs to tab


   TObjArray           *fDrawnFunctions;
   Double_t            *fSaxis;
   Double_t            *fYaxisBuffer;
   Int_t                fNSPoints;
   
   TLegend             *fLegend; 
   
   TAxis               *fYaxis;

   static const Int_t fgkComboWidth;


   ClassDef(MadxViewerPar, 0) //GUI for editing TGLViewer attributes
};

#endif
